/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 ***************************************************************************
 * Projekt : Zeus
 * Module  : PersonalDB
 * Package : Examples
 * Author  : Benjamin Hadorn
 * Datum   : $Date$
 * Ablage  : $File$
 * System  : Zeus-Framework
 ***************************************************************************
 * Licence:                                                                *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version             *
 *   2.1 of the License, or (at your option) any later version.            *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA  *
 ***************************************************************************/

/***************************************************************************
 Changes :
 $Log$
***************************************************************************/
//---------------------------------------------------------------------------

#include <vcl.h>
#include <zeusbase/System/SingletonManager.h>
#include <zeusbase/System/LibraryManager.h>
#include <zeusbase/System/ZObjectFactory.h>
#include <PersonDB.h>
#include <Person.h>
#include <frmMainForm.h>


#pragma hdrstop

USING_NAMESPACE_Zeus

//---------------------------------------------------------------------------
USEFORM("..\src\frmMainForm.cpp", Form1);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{

  TString strSingName = L"IZObjectFactory";
  TSingletonManager::getInstance().addSingleton(strSingName, (IZObjectFactory&)ZObjectFactory);

  //Registrieren der DB Klassen
  XOBJECTFACTORY_REGISTER_ROOT(TPersonDB);
  XOBJECTFACTORY_REGISTER_SUB(TPerson);


  //---------------------------------------------------------------------
  try
  {
     Application->Initialize();
     Application->CreateForm(__classid(TForm1), &Form1);
     Application->Run();
  }
  catch (Exception &exception)
  {
     Application->ShowException(&exception);
  }
  catch (...)
  {
     try
     {
       throw Exception("");
     }
     catch (Exception &exception)
     {
       Application->ShowException(&exception);
     }
  }

  if (Form1 != NULL)
  {
    Form1->releaseInstances();
  }

  TLibraryManager::getInstance().removeAll();
  TSingletonManager::getInstance().removeAll(); /*MUST BE AT THE END*/

  return 0;
}
//---------------------------------------------------------------------------
