/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 *************************************************************************** 
 * Projekt : Zeus
 * Module  : IXRootObject
 * Package : System
 * Author  : Benjamin Hadorn
 * Datum   : $Date: 26.09.06 6:43 $
 * Ablage  : $File$
 * System  : Cell Computing Model
 ***************************************************************************
 * Licence:                                                                *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version             *
 *   2.1 of the License, or (at your option) any later version.            *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA  *
 ***************************************************************************/

/***************************************************************************
 Changes :
 $Log: /WinSteuerung2/dev/Zeus/src/zeusbase/System/Interfaces/IXRootObject.hpp $
** 
** 1     26.09.06 6:43 bha
***************************************************************************/

#ifndef IXRootObjectHPP
#define IXRootObjectHPP

#include <zeusbase/System/Interfaces/IString.hpp>
#include <zeusbase/System/Interfaces/IZUnknown.hpp>

BEGIN_NAMESPACE_Zeus

#define INTERFACE_IXRootObject     0x00000014


/***************************************************************************/
/*! Interface of the root object of an X-Object tree
*/
/***************************************************************************/
class IXRootObject : public IZUnknown
{
  public:

    /***********************************************************************/
    /*! Stores the data tree of XObjects back into a file.
        \return See IXMLDocument for error codes
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER save() =0;

    /***********************************************************************/
    /*! Stores the data tree of XObjects back into a file.
        \param rFileName : Name of the file
        \return See IXMLDocument for error codes
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER saveAs(const IString& rFileName) =0;
};

END_NAMESPACE_Zeus

#endif
