/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 ***************************************************************************
 * Projekt : Zeus
 * Module  : IPerson
 * Package : Examples
 * Author  : Benjamin Hadorn
 * Datum   : $Date$
 * Ablage  : $File$
 * System  : Zeus-Framework
 ***************************************************************************
 * Licence:                                                                *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version             *
 *   2.1 of the License, or (at your option) any later version.            *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA  *
 ***************************************************************************/

/***************************************************************************
 Changes :
 $Log$
***************************************************************************/

#ifndef IPersonHPP
#define IPersonHPP


#include <zeusbase/System/Interfaces/IZUnknown.hpp>
#include <zeusbase/System/Interfaces/IString.hpp>


BEGIN_NAMESPACE_Zeus

#define INTERFACE_IPerson     0x10000004

/***************************************************************************/
/*! This interface represents the person
*/
/***************************************************************************/
class IPerson : public IZUnknown
{
  public:
    /***********************************************************************/
    /*! Returns the ID of the person
    */
    /***********************************************************************/
    virtual unsigned long MQUALIFIER getPersonID() const = 0;

    /***********************************************************************/
    /*! gets the last name of the person
    */
    /***********************************************************************/
    virtual void MQUALIFIER getLastName(IString& rName) const=0;

    /***********************************************************************/
    /*! gets the name of the person
    */
    /***********************************************************************/
    virtual void MQUALIFIER getFirstName(IString& rName) const=0;

    /***********************************************************************/
    /*! sets the last name of the person
    */
    /***********************************************************************/
    virtual void MQUALIFIER setLastName(const IString& rName)=0;

    /***********************************************************************/
    /*! sets the name of the person
    */
    /***********************************************************************/
    virtual void MQUALIFIER setFirstName(const IString& rName)=0;
};

END_NAMESPACE_Zeus

#endif
 