/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 ***************************************************************************
 * Projekt : Zeus
 * Module  : Person
 * Package : Examples
 * Author  : Benjamin Hadorn
 * Datum   : $Date$
 * Ablage  : $File$
 * System  : Zeus-Framework
 ***************************************************************************
 * Licence:                                                                *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version             *
 *   2.1 of the License, or (at your option) any later version.            *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA  *
 ***************************************************************************/

/***************************************************************************
 Changes :
 $Log$
***************************************************************************/
//---------------------------------------------------------------------------



#include "Person.h"

//---------------------------------------------------------------------------

USING_NAMESPACE_Zeus

//---------------------------------------------------------------------------
/***************************************************************************/
/*! Creates a person
    \param rName : Name
    \param rLastName : Last name of the person
*/
/***************************************************************************/
TPerson::TPerson(IXMLNode& rNode) : TXObject(rNode)
{}


/***************************************************************************/
/*! Destroyys the person
*/
/***************************************************************************/
TPerson::~TPerson()
{}


/***************************************************************************/
/*! \see IPerson::getPersonID
*/
/***************************************************************************/
unsigned long MQUALIFIER TPerson::getPersonID() const
{
  return this->getID();
}

/***************************************************************************/
/*! \see IPerson::getLastName
*/
/***************************************************************************/
void MQUALIFIER TPerson::getLastName(IString& rName) const
{
  this->m_pNode->getAttributeValue(TString(L"LastName"), rName);
}

/***************************************************************************/
/*! \see IPerson::getName
*/
/***************************************************************************/
void MQUALIFIER TPerson::getFirstName(IString& rName) const
{
  this->m_pNode->getAttributeValue(TString(L"Name"), rName);
}

/***************************************************************************/
/*! \see IPerson::setLastName
*/
/***************************************************************************/
void MQUALIFIER TPerson::setLastName(const IString& rName)
{
  this->m_pNode->setAttributeValue(TString(L"LastName"), rName);
}

/***************************************************************************/
/*! \see IPerson::setName
*/
/***************************************************************************/
void MQUALIFIER TPerson::setFirstName(const IString& rName)
{
  this->m_pNode->setAttributeValue(TString(L"Name"), rName);
}

/***************************************************************************/
/*! Memory management
*/
/***************************************************************************/
MEMORY_MANAGER_IMPL(TPerson);
  INTERFACE_CAST(IPerson, INTERFACE_IPerson);
MEMORY_MANAGER_IMPL_PARENT_END(TXObject);


