/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 ***************************************************************************
 * Projekt : Zeus
 * Module  : Person
 * Package : Examples
 * Author  : Benjamin Hadorn
 * Datum   : $Date$
 * Ablage  : $File$
 * System  : Zeus-Framework
 ***************************************************************************
 * Licence:                                                                *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version             *
 *   2.1 of the License, or (at your option) any later version.            *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA  *
 ***************************************************************************/

/***************************************************************************
 Changes :
 $Log$
***************************************************************************/
//---------------------------------------------------------------------------

#ifndef PersonH
#define PersonH


#include <zeusbase/System/XObject.h>
#include <zeusbase/System/XObjectFactory.h>
#include <Interfaces/IPerson.hpp>

BEGIN_NAMESPACE_Zeus


/***************************************************************************/
/*! Implementation of a person
*/
/***************************************************************************/
class TPerson : public TXObject, public IPerson
{
  public:
    TPerson(IXMLNode& rNode);

    //Methods of IPerson
    virtual unsigned long MQUALIFIER getPersonID() const ;
    virtual void MQUALIFIER getLastName(IString& rName) const;
    virtual void MQUALIFIER getFirstName(IString& rName) const;
    virtual void MQUALIFIER setLastName(const IString& rName);
    virtual void MQUALIFIER setFirstName(const IString& rName);

    REG_SUB_BEGIN(TPerson)
    REG_SUB_ADD(TPerson, L"TPerson");
    REG_SUB_END

    //Memory management
    MEMORY_MANAGER_DECL

  protected:
    virtual ~TPerson();

  private:
};


END_NAMESPACE_Zeus

//---------------------------------------------------------------------------
#endif
