/***************************************************************************
 * Copyright (C) 2005 by Benjamin Hadorn (bhadorn@swissinfo.org)           *
 ***************************************************************************
 * Projekt : Zeus
 * Module  : frmMainForm
 * Package : Examples
 * Author  : Benjamin Hadorn
 * Datum   : $Date$
 * Ablage  : $File$
 * System  : Zeus-Framework
 ***************************************************************************
 * Licence:                                                                *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version             *
 *   2.1 of the License, or (at your option) any later version.            *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA  *
 ***************************************************************************/

/***************************************************************************
 Changes :
 $Log$
***************************************************************************/
//---------------------------------------------------------------------------

#ifndef frmMainFormH
#define frmMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "ExtCtrls.hpp"
#include "StdCtrls.hpp"
#include <ExtCtrls.hpp>
#include "Dialogs.hpp"
#include <Dialogs.hpp>

#include <zeusbase/System/ZObject.h>

USING_NAMESPACE_Zeus

BEGIN_NAMESPACE_Zeus
  class IPersonDB;
  class IPerson;
END_NAMESPACE_Zeus


//---------------------------------------------------------------------------
/***************************************************************************/
/*! This form shows the content and the navigation of the personal database
*/
/***************************************************************************/
class TForm1 : public TForm
{
  __published:
    TPanel *Panel1;
    TLabel *Label1;
    TLabel *m_lbFilename;
    TButton *Button1;
    TBevel *Bevel1;
    TButton *m_btnSave;
    TGroupBox *m_grpPerson;
    TButton *Button3;
    TLabel *m_lbID;
    TLabel *m_lbName;
    TLabel *m_lbVorName;
  TLabel *m_lbIDOut;
    TEdit *m_edtName;
    TEdit *m_edtVorname;
    TButton *m_btnPrev;
    TButton *m_btnNext;
    TButton *m_btnDelete;
    TOpenDialog *m_dlgOpen;
    TSaveDialog *m_dlgSave;
  TButton *m_btnSet;
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall m_btnSaveClick(TObject *Sender);
    void __fastcall m_btnPrevClick(TObject *Sender);
    void __fastcall m_btnNextClick(TObject *Sender);
    void __fastcall Button3Click(TObject *Sender);
  void __fastcall m_btnSetClick(TObject *Sender);
  void __fastcall m_btnDeleteClick(TObject *Sender);

  public:

    __fastcall TForm1(TComponent* Owner);
    virtual __fastcall ~TForm1();

    void releaseInstances();

  private:
    ///File name of the data base
    TString m_strFileName;
    ///Data base object
    IPersonDB* m_pPersonDB;
    ///Actual index of the person to show
    long m_lIndex;

    bool openDB(const IString& rFileName);
    bool saveDB();
    void closeDB();
    void newDB();
    void showEntry(long& lIndex);
};

//END_NAMESPACE_Zeus

//---------------------------------------------------------------------------
extern PACKAGE TForm1* Form1;
//---------------------------------------------------------------------------

#endif
